---
title: outline
slug: Web/CSS/outline
tags:
  - CSS
  - CSS Outline
  - CSS Property
  - Layout
  - Reference
  - 'recipe:css-shorthand-property'
---
<div>{{CSSRef}}</div>

<p>The <strong><code>outline</code></strong> <a href="/en-US/docs/Web/CSS">CSS</a> <a href="/en-US/docs/Web/CSS/Shorthand_properties">shorthand property</a> set all the outline properties in a single declaration.</p>

<div>{{EmbedInteractiveExample("pages/css/outline.html")}}</div>

<div class="hidden">The source for this interactive example is stored in a GitHub repository. If you'd like to contribute to the interactive examples project, please clone <a href="https://github.com/mdn/interactive-examples">https://github.com/mdn/interactive-examples</a> and send us a pull request.</div>

<h2 id="Constituent_properties">Constituent properties</h2>

<p>This property is a shorthand for the following CSS properties:</p>

<ul>
  <li>{{cssxref("outline-color")}}</li>
  <li>{{cssxref("outline-style")}}</li>
  <li>{{cssxref("outline-width")}}</li>
</ul>

<h2 id="Syntax">Syntax</h2>

<pre class="brush: css no-line-numbers notranslate">/* style */
outline: solid;

/* color | style */
outline: #f66 dashed;

/* style | width */
outline: inset thick;

/* color | style | width */
outline: green solid 3px;

/* Global values */
outline: inherit;
outline: initial;
outline: unset;
</pre>

<p>The <code>outline</code> property may be specified using one, two, or three of the values listed below. The order of the values does not matter.</p>

<div class="note">
<p><strong>Note:</strong> The outline will be invisible for many elements if its style is not defined. This is because the style defaults to <code>none</code>. A notable exception is <code>input</code> elements, which are given default styling by browsers.</p>
</div>

<h3 id="Values">Values</h3>

<dl>
 <dt><code>&lt;'outline-color'&gt;</code></dt>
 <dd>Sets the color of the outline. Defaults to <code>currentcolor</code> if absent. See {{cssxref("outline-color")}}.</dd>
 <dt><code>&lt;'outline-style'&gt;</code></dt>
 <dd>Sets the style of the outline. Defaults to <code>none</code> if absent. See {{cssxref("outline-style")}}.</dd>
 <dt><code>&lt;'outline-width'&gt;</code></dt>
 <dd>Sets the thickness of the outline. Defaults to <code>medium</code> if absent. See {{cssxref("outline-width")}}.</dd>
</dl>

<h2 id="Description">Description</h2>

<p><a href="/en-US/docs/Web/CSS/border">Borders</a> and outlines are very similar. However, outlines differ from borders in the following ways:</p>

<ul>
 <li>Outlines never take up space, as they are drawn outside of an element's content.</li>
 <li>According to the spec, outlines don't have to be rectangular, although they usually are.</li>
</ul>

<p>As with all shorthand properties, any omitted sub-values will be set to their <a href="/en-US/docs/Web/CSS/initial_value">initial value</a>.</p>

<h2 id="Accessibility_concerns">Accessibility concerns</h2>

<p>Assigning <code>outline</code> a value of <code>0</code> or <code>none</code> will remove the browser's default focus style. If an element can be interacted with it must have a visible focus indicator. Provide obvious focus styling if the default focus style is removed.</p>

<ul>
 <li><a href="https://www.deque.com/blog/give-site-focus-tips-designing-usable-focus-indicators/">How to Design Useful and Usable Focus Indicators</a></li>
 <li>
  <p><abbr>WCAG</abbr> 2.1: <a href="https://www.w3.org/WAI/WCAG21/Understanding/focus-visible.html">Understanding Success Criterion 2.4.7: Focus Visible</a></p>
 </li>
</ul>

<h2 id="Formal_definition">Formal definition</h2>

<p>{{cssinfo}}</p>

<h2 id="Formal_syntax">Formal syntax</h2>

<pre class="syntaxbox notranslate">{{csssyntax}}</pre>

<h2 id="Examples">Examples</h2>

<h3 id="Using_outline_to_set_a_focus_style">Using outline to set a focus style</h3>

<h4 id="HTML">HTML</h4>

<pre class="brush: html notranslate">&lt;a href="#"&gt;This link has a special focus style.&lt;/a&gt;
</pre>

<h4 id="CSS">CSS</h4>

<pre class="brush: css notranslate">a {
  border: 1px solid;
  border-radius: 3px;
  display: inline-block;
  margin: 10px;
  padding: 5px;
}

a:focus {
  outline: 4px dotted #e73;
  outline-offset: 4px;
  background: #ffa;
}
</pre>

<h4 id="Result">Result</h4>

<p>{{EmbedLiveSample("Using_outline_to_set_a_focus_style", "100%", 60)}}</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>{{SpecName('CSS3 Basic UI', '#outline', 'outline')}}</td>
   <td>{{Spec2('CSS3 Basic UI')}}</td>
   <td>No change.</td>
  </tr>
  <tr>
   <td>{{SpecName('CSS2.1', 'ui.html#propdef-outline', 'outline')}}</td>
   <td>{{Spec2('CSS2.1')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("css.properties.outline")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{cssxref("outline-color")}}</li>
 <li>{{cssxref("outline-style")}}</li>
 <li>{{cssxref("outline-width")}}</li>
</ul>